
public class EnversAuditListener implements RevisionListener
{

    //~ Methods ------------------------------------------------------------------------------------

    @Override
    public void newRevision(Object arg0)
    {

        EnversAuditTrail eai       = (EnversAuditTrail) arg0;
        ModelOperation   operation = ModelOperation.current();

        if (operation != null)
        {
            eai.setModifiedBy(operation.getWho());
            eai.setModifyReason(operation.getWhy());
            eai.setOperationType(operation.getOperationType());
        }
        else
        {
            throw new NoModelOperationException(
                "There is no current ModelOperation. You must create a ModelOperation record before changing the database!"
            );
        }

    }

    //~ Inner Classes ------------------------------------------------------------------------------

    public class NoModelOperationException extends RuntimeException
    {

        //~ Static fields/initializers -------------------------------------------------------------

        /** Use serialVersionUID for interoperability. */
        private static final long serialVersionUID = 3014820808636008890L;

        //~ Constructors ---------------------------------------------------------------------------

        /**
         * Creates a new NoModelOperationException object.
         *
         */
        public NoModelOperationException(String message)
        {
            super(message);
        }

    }
} // end class EnversAuditListener
